export default function getStyles() {
  return "\n/* HINTS */\n\n.react-hint-popover, \n.react-hint-popover *,\n.react-hint,\n.react-hint * {\n  -webkit-box-sizing: border-box;\n  -moz-box-sizing: border-box;\n  box-sizing: border-box;\n}\n\n@-webkit-keyframes \"hint-wave\" {\n 0% {\n    -webkit-transform: scale(0);\n    opacity: 0.0;\n }\n 25% {\n    -webkit-transform: scale(0);\n    opacity: 0.1;\n }\n 50% {\n    -webkit-transform: scale(0.1);\n    opacity: 0.3;\n }\n 75% {\n    -webkit-transform: scale(0.5);\n    opacity: 0.5;\n }\n 100% {\n    -webkit-transform: scale(1.5);\n    opacity: 0.0;\n }\n}\n\n@-moz-keyframes \"hint-wave\" {\n 0% {\n    -moz-transform: scale(0);\n    opacity: 0.0;\n }\n 25% {\n    -moz-transform: scale(0);\n    opacity: 0.1;\n }\n 50% {\n    -moz-transform: scale(0.1);\n    opacity: 0.3;\n }\n 75% {\n    -moz-transform: scale(0.5);\n    opacity: 0.5;\n }\n 100% {\n    -moz-transform: scale(1.5);\n    opacity: 0.0;\n }\n}\n@keyframes \"hint-wave\" {\n 0% {\n    transform: scale(0);\n    opacity: 0.0;\n }\n 25% {\n    transform: scale(0);\n    opacity: 0.1;\n }\n 50% {\n    transform: scale(0.1);\n    opacity: 0.3;\n }\n 75% {\n    transform: scale(0.5);\n    opacity: 0.5;\n }\n 100% {\n    transform: scale(1.5);\n    opacity: 0.0;\n }\n}\n\n.react-hint {\n  position: absolute;\n  width: 20px;\n  height: 20px;\n  border: 2px solid rgba(60, 60, 60, 0.27);\n  -webkit-border-radius: 30px;\n  -moz-border-radius: 30px;\n  border-radius: 30px;\n\n  z-index: 10;\n  -webkit-transition: all 0.2s ease-out;\n  -moz-transition: all 0.2s ease-out;\n  -ms-transition: all 0.2s ease-out;\n  -o-transition: all 0.2s ease-out;\n  transition: all 0.2s ease-out;\n\n  box-shadow: 2px 2px 5px rgba(60, 60, 60, 0.27);\n}\n.react-hint .wave{\n  border: 10px solid rgba(146, 146, 146, 0.36);\n  background: transparent;\n  -webkit-border-radius: 60px;\n  -moz-border-radius: 60px;\n  border-radius: 60px;\n  height: 50px;\n  width: 50px;\n  -webkit-animation: hint-wave 3s ease-out;\n  -moz-animation: hint-wave 3s ease-out;\n  animation: hint-wave 3s ease-out;\n  -webkit-animation-iteration-count: infinite;\n  -moz-animation-iteration-count: infinite;\n  animation-iteration-count: infinite;\n  position: absolute;\n  top: -17px;\n  left: -17px;\n  z-index: 1;\n  opacity: 0;\n}\n\n.react-hint .inner{\n  width: 10px;\n  height: 10px;\n  -webkit-border-radius: 30px;\n  -moz-border-radius: 30px;\n  border-radius: 30px;\n  background-color: rgba(60, 60, 60, 0.27);\n  z-index: 10;\n  position: absolute;\n  top: 3px;\n  left: 3px;\n  -webkit-transition: border-color 0.2s ease-out;\n  -moz-transition: border-color 0.2s ease-out;\n  -ms-transition: border-color 0.2s ease-out;\n  -o-transition: border-color 0.2s ease-out;\n  transition: border-color 0.2s ease-out;\n}\n\n.react-hint:hover{\n  border: 2px solid rgba(60, 60, 60, 0.57);\n}\n.react-hint:hover .inner{\n  border: 5px solid rgba(60, 60, 60, 0.57);\n  width: 0px;\n  height: 0px;\n}\n\n.react-hint-popover.fade {\n  opacity: 0;\n  -webkit-transition: opacity .15s linear;\n  -o-transition: opacity .15s linear;\n  transition: opacity .15s linear;\n}\n.react-hint-popover.fade.in {\n  opacity: 1\n}\n\n\n/* \nPOP OVER STYLES\nExtracted from Bootstrap\n*/\n\n.react-hint-popover button {\n  color: inherit;\n  font: inherit;\n  margin: 0;\n  overflow: visible;\n  text-transform: none;\n  -webkit-appearance: button;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  line-height: inherit;\n}\n\n.react-hint-popover button::-moz-focus-inner{\n  border: 0;\n  padding: 0;\n}\n\n.react-hint-popover .btn {\n  display: inline-block;\n  margin-bottom: 0;\n  font-weight: normal;\n  text-align: center;\n  vertical-align: middle;\n  -ms-touch-action: manipulation;\n      touch-action: manipulation;\n  cursor: pointer;\n  background-image: none;\n  border: 1px solid transparent;\n  white-space: nowrap;\n  padding: 6px 12px;\n  font-size: 14px;\n  line-height: 1.42857143;\n  border-radius: 4px;\n  -webkit-user-select: none;\n  -moz-user-select: none;\n  -ms-user-select: none;\n  user-select: none;\n}\n.react-hint-popover .btn:focus,\n.react-hint-popover .btn:active:focus,\n.react-hint-popover .btn.active:focus,\n.react-hint-popover .btn.focus,\n.react-hint-popover .btn:active.focus,\n.react-hint-popover .btn.active.focus {\n  outline: 5px auto -webkit-focus-ring-color;\n  outline-offset: -2px;\n}\n.react-hint-popover .btn:hover,\n.react-hint-popover .btn:focus,\n.react-hint-popover .btn.focus {\n  color: #333333;\n  text-decoration: none;\n}\n.react-hint-popover .btn:active,\n.react-hint-popover .btn.active {\n  outline: 0;\n  background-image: none;\n  -webkit-box-shadow: inset 0 3px 5px rgba(0, 0, 0, 0.125);\n  box-shadow: inset 0 3px 5px rgba(0, 0, 0, 0.125);\n}\n.react-hint-popover .btn.disabled,\n.react-hint-popover .btn[disabled],\n.react-hint-popover fieldset[disabled] .btn {\n  cursor: not-allowed;\n  opacity: 0.65;\n  filter: alpha(opacity=65);\n  -webkit-box-shadow: none;\n  box-shadow: none;\n}\n.react-hint-popover a.btn.disabled,\n.react-hint-popover fieldset[disabled] a.btn {\n  pointer-events: none;\n}\n.react-hint-popover .btn-default {\n  color: #333333;\n  background-color: #ffffff;\n  border-color: #cccccc;\n}\n.react-hint-popover .btn-default:focus,\n.react-hint-popover .btn-default.focus {\n  color: #333333;\n  background-color: #e6e6e6;\n  border-color: #8c8c8c;\n}\n.react-hint-popover .btn-default:hover {\n  color: #333333;\n  background-color: #e6e6e6;\n  border-color: #adadad;\n}\n.react-hint-popover .btn-default:active,\n.react-hint-popover .btn-default.active,\n.react-hint-popover .open > .dropdown-toggle.btn-default {\n  color: #333333;\n  background-color: #e6e6e6;\n  border-color: #adadad;\n}\n.react-hint-popover .btn-default:active:hover,\n.react-hint-popover .btn-default.active:hover,\n.react-hint-popover .open > .dropdown-toggle.btn-default:hover,\n.react-hint-popover .btn-default:active:focus,\n.react-hint-popover .btn-default.active:focus,\n.react-hint-popover .open > .dropdown-toggle.btn-default:focus,\n.react-hint-popover .btn-default:active.focus,\n.react-hint-popover .btn-default.active.focus,\n.react-hint-popover .open > .dropdown-toggle.btn-default.focus {\n  color: #333333;\n  background-color: #d4d4d4;\n  border-color: #8c8c8c;\n}\n.react-hint-popover .btn-default:active,\n.react-hint-popover .btn-default.active,\n.react-hint-popover .open > .dropdown-toggle.btn-default {\n  background-image: none;\n}\n.react-hint-popover .btn-default.disabled:hover,\n.react-hint-popover .btn-default[disabled]:hover,\n.react-hint-popover fieldset[disabled] .btn-default:hover,\n.react-hint-popover .btn-default.disabled:focus,\n.react-hint-popover .btn-default[disabled]:focus,\n.react-hint-popover fieldset[disabled] .btn-default:focus,\n.react-hint-popover .btn-default.disabled.focus,\n.react-hint-popover .btn-default[disabled].focus,\n.react-hint-popover fieldset[disabled] .btn-default.focus {\n  background-color: #ffffff;\n  border-color: #cccccc;\n}\n\n.react-hint-popover .btn-sm {\n  padding: 5px 10px;\n  font-size: 12px;\n  line-height: 1.5;\n  border-radius: 3px;\n}\n\n.react-hint-popover.popover {\n  position: absolute;\n  top: 0;\n  left: 0;\n  z-index: 1060;\n  display: none;\n  max-width: 276px;\n  padding: 1px;\n  font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n  font-style: normal;\n  font-weight: normal;\n  letter-spacing: normal;\n  line-break: auto;\n  line-height: 1.42857143;\n  text-align: left;\n  text-align: start;\n  text-decoration: none;\n  text-shadow: none;\n  text-transform: none;\n  white-space: normal;\n  word-break: normal;\n  word-spacing: normal;\n  word-wrap: normal;\n  font-size: 14px;\n  background-color: #ffffff;\n  -webkit-background-clip: padding-box;\n          background-clip: padding-box;\n  border: 1px solid #cccccc;\n  border: 1px solid rgba(0, 0, 0, 0.2);\n  border-radius: 6px;\n  -webkit-box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);\n  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);\n}\n.react-hint-popover.popover.top {\n  margin-top: -10px;\n}\n.react-hint-popover.popover.right {\n  margin-left: 10px;\n}\n.react-hint-popover.popover.bottom {\n  margin-top: 10px;\n}\n.react-hint-popover.popover.left {\n  margin-left: -10px;\n}\n.react-hint-popover .popover-title {\n  margin: 0;\n  padding: 8px 14px;\n  font-size: 14px;\n  background-color: #f7f7f7;\n  border-bottom: 1px solid #ebebeb;\n  border-radius: 5px 5px 0 0;\n}\n.react-hint-popover .popover-content {\n  padding: 9px 14px;\n}\n.react-hint-popover.popover > .arrow,\n.react-hint-popover.popover > .arrow:after {\n  position: absolute;\n  display: block;\n  width: 0;\n  height: 0;\n  border-color: transparent;\n  border-style: solid;\n}\n.react-hint-popover.popover > .arrow {\n  border-width: 11px;\n}\n.react-hint-popover.popover > .arrow:after {\n  border-width: 10px;\n  content: \"\";\n}\n.react-hint-popover.popover.top > .arrow {\n  left: 50%;\n  margin-left: -11px;\n  border-bottom-width: 0;\n  border-top-color: #999999;\n  border-top-color: rgba(0, 0, 0, 0.25);\n  bottom: -11px;\n}\n.react-hint-popover.popover.top > .arrow:after {\n  content: \" \";\n  bottom: 1px;\n  margin-left: -10px;\n  border-bottom-width: 0;\n  border-top-color: #ffffff;\n}\n.react-hint-popover.popover.right > .arrow {\n  top: 50%;\n  left: -11px;\n  margin-top: -11px;\n  border-left-width: 0;\n  border-right-color: #999999;\n  border-right-color: rgba(0, 0, 0, 0.25);\n}\n.react-hint-popover.popover.right > .arrow:after {\n  content: \" \";\n  left: 1px;\n  bottom: -10px;\n  border-left-width: 0;\n  border-right-color: #ffffff;\n}\n.react-hint-popover.popover.bottom > .arrow {\n  left: 50%;\n  margin-left: -11px;\n  border-top-width: 0;\n  border-bottom-color: #999999;\n  border-bottom-color: rgba(0, 0, 0, 0.25);\n  top: -11px;\n}\n.react-hint-popover.popover.bottom > .arrow:after {\n  content: \" \";\n  top: 1px;\n  margin-left: -10px;\n  border-top-width: 0;\n  border-bottom-color: #ffffff;\n}\n.react-hint-popover.popover.left > .arrow {\n  top: 50%;\n  right: -11px;\n  margin-top: -11px;\n  border-right-width: 0;\n  border-left-color: #999999;\n  border-left-color: rgba(0, 0, 0, 0.25);\n}\n.react-hint-popover.popover.left > .arrow:after {\n  content: \" \";\n  right: 1px;\n  border-right-width: 0;\n  border-left-color: #ffffff;\n  bottom: -10px;\n}\n  ";
}